shell高级编程笔记(1-2)

第一部分 热身

shell 是一个命令解释器.是介于操作系统kernel与用户之间的一个绝缘层。它可以将系统调用、公共程序、工具和编译过的二进制程序粘合在一起来建立应用。

shell 脚本对于管理系统任务和其它的重复工作的例程来说表现的非常好,根本不需要那些华而不实的、成熟紧凑的程序语言。

第一章 为什么使用shell编程

对于任何想适当精通一些系统管理知识的人来说,掌握shell脚本知识都是最基本的。

Linux机器的启动过程中,必将运行/etc/rc.d目录下的脚本来存储系统配置和建立服务,详细的理解这些启动脚本对于分析系统的行为是非常重要的,并且有时候可能必须修改它。

Shell脚本遵循典型的UNIX哲学,就是把大的复杂的工程分成小规模的子任务,并且把这些部件和工具组合起来。许多人认为这种办法更好一些,至少这种办法比使用那种高、大、全的语言更美、更愉悦、更适合解决问题。

Bash是“Bourne-Again shell”首字母的缩写,也是Stephen Bourne的经典的Bourne shell的一个双关语。Bash已经成为所有UNIX中shell脚本的标准。

什么时候不使用Shell脚本
1、资源密集型的任务,尤其在需要考虑效率时(比如:排序、hash等)
2、需要处理大任务的数学操作,尤其是浮点运算、精确运算或者复杂的算术运算(这种情况一般使用C++或者FORTRAN来处理)
3、有跨平台移植需求(一般使用C或者Java)
4、复杂的应用,在必须使用结构化编程的时候(需要变量的类型检查、函数远程等)
5、对于影响系统全局性的关键任务应用
6、对于安全有很高的要求的任务,比如你需要一个健壮的系统来防止入侵、破解、恶意破坏等
7、项目由连串的依赖的各个部分组成
8、需要大规模的文件操作,需要多维数组的支持
9、需要数据结构的支持,比如链表或数等数据结构
10、需要直接操作系统硬件、需要I/O或socket接口
11、需要使用库或者遗留下来的老代码接口

第二章 带着一个Sha-Bang出发

Sha-Bang指的是#!
Example 2.1 一个清除/var/log下的log文件的脚本

#!/bin/bash
#清除脚本v1
#要使用根用户执行脚本
LOG_DIR=/var/log
cd $LOG_DIR

cat /dev/null > messages
cat /dev/null > wtmp

echo "Logs cleaned up."

exit   #这是一种正确并且合适点的退出脚本的方法

Example 2.3 一个真正意义上的清除/var/log下的log文件的脚本

#!/bin/bash
#清除脚本v2
LOG_DIR=/var/log
ROOT_UID=0   #UID为0的时候,用户才具有根用户的权限
LINES=50   #默认保存的行数
E_XCD=66   #非当前目录将以error退出
E_NOTROOT=67   #非根用户将以error退出

#要使用根用户来运行
if [ "$UID" -ne "$ROOT_UID" ];then
  echo "Must bo root to run this script."
  exit $E_NOTROOT
fi

#判断是否有命令行参数
if [ -n "$1" ];then
  lines = $1
else
  lines = $LINES   #默认,如果不在命令行中指定
fi
#上面的命令行参数判断经过优化之后(设置LINES默认值):lines=${1:-$LINES}

cd $LOG_DIR

#在处理log file之前,再确认一遍当前目录是否正确
if [ `pwd` != "$LOG_DIR" ];then
  echo "Can't change to $LOG_DIR"
  exit $E_XCD
fi
#更有效率的做法是
#cd /var/log || {
#    echo "Cannot change to necessary directory." >&2
#    exit $E_XCD;
#}

tail -$lines messages > mesg.temp   #保存log file消息的最后部分
mv mesg.temp messages   #变为新的log目录

cat /dev/null > wtmp    #不需要保留旧消息最后部分的做法
echo "Logs cleaned up."

exit 0

注意:
在每个脚本的开头都使用#!,这意味着告诉你的系统这个文件的执行需要指定一个解释器。
#!其实是一个2字节的魔法数字,这是指定一个文件类型的特殊标记,换句话说,在这种情况下,指的就是一个可执行的脚本。
在#!之后接着是一个路径名。这个路径名指定了一个解释脚本中命令的程序,这个程序可以是shell程序语言或者是任意一个通用程序。这个指定的程序从头开始解释并执行脚本中的命令,忽略注释
如:
#!/bin/sh
#!bin/bash
#!/usr/bin/perl
#!/usr/bin/tcl
#!/bin/sed -f
#!/usr/awk -f

上边的每一个脚本头的行都指定了一个不同的命令解释器,如果是/bin/sh,那么就是默认shell(在Linux系统中默认是Bash)。
使用#!/bin/sh,在大多数商业发型的UNIX上,默认是Bourne shell,这将让你的脚本可以正常地运行在非Linux机器上,虽然这将会牺牲Bash一些独特的特征

当然#!也可以被忽略,不过这样你的脚本文件就只能是一些命令的集合,不能使用shell内建的指令了,如果不能使用变量的话,这也就是去了脚本编程的意义了。

2.1 调用一个脚本

编写完脚本后,你可以使用sh scriptname或者bash scriptname来调用它;更方便的方法是让脚本本身具有可执行权限,那么就可以./scriptname来调用脚本。

2.2 初步的练习

  1. 系统管理员经常为了自动化一些常用的任务而编写脚本。举出几个这种有用的脚本的实例

  2. 编写一个脚本,显示时间和日期、列出所有的登录用户、显示系统的更新时间(不知道是啥),然后这个脚本将会把这些内容保存到一个log file中

#!/bin/sh
#example1.sh

{
#显示时间和日期
time=`date +%H时%M分%S秒`
date=`date +%Y年%m月%d日`
echo "当前时间是:$time"
echo "当前日期是:$date"

#列出所有的登录用户
user=`w -h | awk '{print $1}'`
echo "当前的登录用户有:$user"
} >> example1.log

exit 0
展开阅读全文

Git 实用技巧

11-24
这几年越来越多的开发团队使用了Git,掌握Git的使用已经越来越重要,已经是一个开发者必备的一项技能;但很多人在刚开始学习Git的时候会遇到很多疑问,比如之前使用过SVN的开发者想不通Git提交代码为什么需要先commit然后再去push,而不是一条命令一次性搞定; 更多的开发者对Git已经入门,不过在遇到一些代码冲突、需要恢复Git代码时候就不知所措,这个时候哪些对 Git掌握得比较好的少数人,就像团队中的神一样,在队友遇到 Git 相关的问题的时候用各种流利的操作来帮助队友于水火。 我去年刚加入新团队,发现一些同事对Git的常规操作没太大问题,但对Git的理解还是比较生疏,比如说分支和分支之间的关联关系、合并代码时候的冲突解决、提交代码前未拉取新代码导致冲突问题的处理等,我在协助处理这些问题的时候也记录各种问题的解决办法,希望整理后通过教程帮助到更多对Git操作进阶的开发者。 本期教程学习方法分为“掌握基础——稳步进阶——熟悉协作”三个层次。从掌握基础的 Git的推送和拉取开始,以案例进行演示,分析每一个步骤的操作方式和原理,从理解Git 工具的操作到学会代码存储结构、演示不同场景下Git遇到问题的不同处理方案。循序渐进让同学们掌握Git工具在团队协作中的整体协作流程。 在教程中会通过大量案例进行分析,案例会模拟在工作中遇到的问题,从最基础的代码提交和拉取、代码冲突解决、代码仓库的数据维护、Git服务端搭建等。为了让同学们容易理解,对Git简单易懂,文章中详细记录了详细的操作步骤,提供大量演示截图和解析。在教程的最后部分,会从提升团队整体效率的角度对Git工具进行讲解,包括规范操作、Gitlab的搭建、钩子事件的应用等。 为了让同学们可以利用碎片化时间来灵活学习,在教程文章中大程度降低了上下文的依赖,让大家可以在工作之余进行学习与实战,并同时掌握里面涉及的Git不常见操作的相关知识,理解Git工具在工作遇到的问题解决思路和方法,相信一定会对大家的前端技能进阶大有帮助。
©️2020 CSDN 皮肤主题: 数字20 设计师: CSDN官方博客 返回首页
实付0元
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、C币套餐、付费专栏及课程。

余额充值